<template>
	<address-search @searchData="searchData" @clearData="clearData" :search_params="commomParams.search"></address-search>
	<a-c-operation @refresh="clearData">
		<a-col>
			<a-button type="primary" @click="download">导出参与活动用户</a-button>
		</a-col>
	</a-c-operation>
	<a-c-table :data="commomParams.table.data" :columns="commomParams.table.columns" :pagination="commomParams.page"
		@page="getPage" :loading="loading">
		<template #default="{ record }">
			<a-row :gutter="10">
				<a-col><a-button type="primary" size="small" primary @click="edit(record)">编辑</a-button></a-col>
				<a-popconfirm title="是否删除该地址?" @confirm="delOneRole(record.id)">
					<a-col><a-button type="primary" size="small" danger>删除</a-button></a-col>
				</a-popconfirm>
			</a-row>
		</template>
	</a-c-table>
	<address-add :edit_record="edit_record" @successAdd="successAdd" @closeAdd="closeAdd"></address-add>
</template>

<script lang="ts" setup>
	import { ref, onMounted, watch, computed } from 'vue';
	import AddressSearch from '@/views/activity/address/search/index.vue';
	import AddressAdd from '@/views/activity/address/add/add.vue';
	import { GetActivityaddressList, PostActivityaddressDel, PostActivityExportUsers } from '@/apis/models';
	import { useCommon } from '@/hooks/useCommon';
	import { cols } from '@/views/activity/address/columns';
	import { message } from 'ant-design-vue';
	let { store, commomParams, showModal, showOtherModal1 } = useCommon();
	let loading = ref<Boolean>(true);
	onMounted(() => {
		getData(commomParams.value.search);
	})

	const searchData = (data : object) => {
		commomParams.value.search = data
		getData();
	}

	const clearData = (data : object) => {
		if (data) {
			commomParams.value.search = data
		} else {
			commomParams.value.search = {
				page: 1,
				pagesize: 10,
				sort: 'id',
				sortby: 'desc',
				keyword: ''
			}
		}
		getData();
	}


	const getPage = (data : object) => {
		commomParams.value.search.page = data.current;
		commomParams.value.search.pagesize = data.pageSize;
		getData();
	}
	const getData = async () => {
		try {
			loading.value = true;
			let res = await GetActivityaddressList(commomParams.value.search);
			loading.value = false;
			commomParams.value.table.data = res.data.addresss;
			commomParams.value.table.columns = cols;
			commomParams.value.page = {
				current: commomParams.value.search.page,
				pageSize: commomParams.value.search.pagesize,
				total: res.data.total,
				pageSizeOptions: ['10', '20', '30', '40'],
				hideOnSinglePage: false,
				showSizeChanger: true
			};
		} catch {
			loading.value = false;
		}
	}


	// 编辑
	let edit_record = ref<Object>(null)
	const edit = (record : object) => {
		edit_record.value = record;
		showModal()
	}
	const successAdd = () => {
		getData();
	}
	const closeAdd = () => {
		edit_record.value = null;
	}


	// 删除
	const delOneRole = (id : number) => {
		commomParams.value.delRecord = { id: id };
		PostActivityaddressDel(commomParams.value.delRecord).then(res => {
			message.success('删除成功');
			getData();
		})
	}
	
	const download = () => {
		PostActivityExportUsers().then(res => {
			let url = 'https://rcsc-test.jcjob.cn/img' + res.data.excel_url;
			window.open(url);
		})
	}
</script>

<style lang="less" scoped>

</style>